

# Module shackle_server #
* [Data Types](#types)
* [Function Index](#index)
* [Function Details](#functions)

<a name="types"></a>

## Data Types ##




### <a name="type-backlog_size">backlog_size()</a> ###


<pre><code>
backlog_size() = pos_integer() | infinity
</code></pre>




### <a name="type-client">client()</a> ###


<pre><code>
client() = module()
</code></pre>




### <a name="type-client_option">client_option()</a> ###


<pre><code>
client_option() = {init_options, <a href="#type-init_options">init_options()</a>} | {ip, <a href="#type-inet_address">inet_address()</a>} | {port, <a href="inet.md#type-port_number">inet:port_number()</a>} | {protocol, <a href="#type-protocol">protocol()</a>} | {reconnect, boolean()} | {reconnect_time_max, <a href="#type-time">time()</a> | infinity} | {reconnect_time_min, <a href="#type-time">time()</a>} | {socket_options, <a href="#type-socket_options">socket_options()</a>}
</code></pre>




### <a name="type-client_options">client_options()</a> ###


<pre><code>
client_options() = [<a href="#type-client_option">client_option()</a>]
</code></pre>




### <a name="type-client_state">client_state()</a> ###


<pre><code>
client_state() = term()
</code></pre>




### <a name="type-inet_address">inet_address()</a> ###


<pre><code>
inet_address() = <a href="inet.md#type-ip_address">inet:ip_address()</a> | <a href="inet.md#type-hostname">inet:hostname()</a>
</code></pre>




### <a name="type-inet_port">inet_port()</a> ###


<pre><code>
inet_port() = <a href="inet.md#type-port_number">inet:port_number()</a>
</code></pre>




### <a name="type-init_options">init_options()</a> ###


<pre><code>
init_options() = term()
</code></pre>




### <a name="type-max_retries">max_retries()</a> ###


<pre><code>
max_retries() = non_neg_integer()
</code></pre>




### <a name="type-pool_name">pool_name()</a> ###


<pre><code>
pool_name() = atom()
</code></pre>




### <a name="type-pool_option">pool_option()</a> ###


<pre><code>
pool_option() = {backlog_size, <a href="#type-backlog_size">backlog_size()</a>} | {max_retries, <a href="#type-max_retries">max_retries()</a>} | {pool_size, <a href="#type-pool_size">pool_size()</a>} | {pool_strategy, <a href="#type-pool_strategy">pool_strategy()</a>}
</code></pre>




### <a name="type-pool_options">pool_options()</a> ###


<pre><code>
pool_options() = [<a href="#type-pool_option">pool_option()</a>]
</code></pre>




### <a name="type-pool_size">pool_size()</a> ###


<pre><code>
pool_size() = pos_integer()
</code></pre>




### <a name="type-pool_strategy">pool_strategy()</a> ###


<pre><code>
pool_strategy() = random | round_robin
</code></pre>




### <a name="type-protocol">protocol()</a> ###


<pre><code>
protocol() = shackle_ssl | shackle_tcp | shackle_udp
</code></pre>




### <a name="type-reconnect_state">reconnect_state()</a> ###


<pre><code>
reconnect_state() = #reconnect_state{current = undefined | <a href="#type-time">time()</a>, max = <a href="#type-time">time()</a> | infinity, min = <a href="#type-time">time()</a>}
</code></pre>




### <a name="type-request_id">request_id()</a> ###


<pre><code>
request_id() = {<a href="#type-server_name">server_name()</a>, reference()}
</code></pre>




### <a name="type-server_id">server_id()</a> ###


<pre><code>
server_id() = {<a href="#type-pool_name">pool_name()</a>, <a href="#type-server_index">server_index()</a>}
</code></pre>




### <a name="type-server_index">server_index()</a> ###


<pre><code>
server_index() = pos_integer()
</code></pre>




### <a name="type-server_name">server_name()</a> ###


<pre><code>
server_name() = atom()
</code></pre>




### <a name="type-server_opts">server_opts()</a> ###


<pre><code>
server_opts() = {<a href="#type-pool_name">pool_name()</a>, <a href="#type-server_index">server_index()</a>, <a href="#type-client">client()</a>, <a href="#type-client_options">client_options()</a>}
</code></pre>




### <a name="type-socket">socket()</a> ###


<pre><code>
socket() = <a href="inet.md#type-socket">inet:socket()</a> | <a href="ssl.md#type-sslsocket">ssl:sslsocket()</a>
</code></pre>




### <a name="type-socket_option">socket_option()</a> ###


<pre><code>
socket_option() = <a href="gen_tcp.md#type-connect_option">gen_tcp:connect_option()</a> | <a href="gen_udp.md#type-option">gen_udp:option()</a> | <a href="ssl.md#type-connect_option">ssl:connect_option()</a>
</code></pre>




### <a name="type-socket_options">socket_options()</a> ###


<pre><code>
socket_options() = [<a href="#type-socket_option">socket_option()</a>]
</code></pre>




### <a name="type-state">state()</a> ###


<pre><code>
state() = #state{address = <a href="#type-inet_address">inet_address()</a>, client = <a href="#type-client">client()</a>, id = <a href="#type-server_id">server_id()</a>, init_options = <a href="#type-init_options">init_options()</a>, name = <a href="#type-server_name">server_name()</a>, parent = pid(), pool_name = <a href="#type-pool_name">pool_name()</a>, port = <a href="#type-inet_port">inet_port()</a>, protocol = <a href="#type-protocol">protocol()</a>, reconnect_state = undefined | <a href="#type-reconnect_state">reconnect_state()</a>, socket = undefined | <a href="#type-socket">socket()</a>, socket_options = <a href="#type-socket_options">socket_options()</a>, timer_ref = undefined | reference()}
</code></pre>




### <a name="type-time">time()</a> ###


<pre><code>
time() = pos_integer()
</code></pre>

<a name="index"></a>

## Function Index ##


<table width="100%" border="1" cellspacing="0" cellpadding="2" summary="function index"><tr><td valign="top"><a href="#handle_msg-2">handle_msg/2</a></td><td></td></tr><tr><td valign="top"><a href="#init-3">init/3</a></td><td></td></tr><tr><td valign="top"><a href="#start_link-2">start_link/2</a></td><td></td></tr><tr><td valign="top"><a href="#terminate-2">terminate/2</a></td><td></td></tr></table>


<a name="functions"></a>

## Function Details ##

<a name="handle_msg-2"></a>

### handle_msg/2 ###

<pre><code>
handle_msg(Msg::term(), X2::{<a href="#type-state">state()</a>, <a href="#type-client_state">client_state()</a>}) -&gt; {ok, term()}
</code></pre>
<br />

<a name="init-3"></a>

### init/3 ###

<pre><code>
init(Name::<a href="#type-server_name">server_name()</a>, Parent::pid(), Opts::<a href="#type-server_opts">server_opts()</a>) -&gt; no_return()
</code></pre>
<br />

<a name="start_link-2"></a>

### start_link/2 ###

<pre><code>
start_link(Name::<a href="#type-server_name">server_name()</a>, Opts::<a href="#type-server_opts">server_opts()</a>) -&gt; {ok, pid()}
</code></pre>
<br />

<a name="terminate-2"></a>

### terminate/2 ###

<pre><code>
terminate(Reason::term(), X2::term()) -&gt; ok
</code></pre>
<br />

